package cn.iocoder.yudao.module.llm.service.finetuning;

import org.springframework.stereotype.Service;
import javax.annotation.Resource;
import org.springframework.validation.annotation.Validated;
import org.springframework.transaction.annotation.Transactional;

import java.util.*;
import cn.iocoder.yudao.module.llm.controller.admin.finetuning.vo.*;
import cn.iocoder.yudao.module.llm.dal.dataobject.finetuning.FineTuningDO;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.common.pojo.PageParam;
import cn.iocoder.yudao.framework.common.util.object.BeanUtils;

import cn.iocoder.yudao.module.llm.dal.mysql.finetuning.FineTuningMapper;

import static cn.iocoder.yudao.framework.common.exception.util.ServiceExceptionUtil.exception;
import static cn.iocoder.yudao.module.llm.enums.ErrorCodeConstants.*;

/**
 * 模型微调 Service 实现类
 *
 * @author 华大大模型
 */
@Service
@Validated
public class FineTuningServiceImpl implements FineTuningService {

    @Resource
    private FineTuningMapper fineTuningMapper;

    @Override
    public Integer createFineTuning(FineTuningSaveReqVO createReqVO) {
        // 插入
        FineTuningDO fineTuning = BeanUtils.toBean(createReqVO, FineTuningDO.class);
        fineTuningMapper.insert(fineTuning);
        // 返回
        return fineTuning.getId();
    }

    @Override
    public void updateFineTuning(FineTuningSaveReqVO updateReqVO) {
        // 校验存在
        validateFineTuningExists(updateReqVO.getId());
        // 更新
        FineTuningDO updateObj = BeanUtils.toBean(updateReqVO, FineTuningDO.class);
        fineTuningMapper.updateById(updateObj);
    }

    @Override
    public void deleteFineTuning(Integer id) {
        // 校验存在
        validateFineTuningExists(id);
        // 删除
        fineTuningMapper.deleteById(id);
    }

    private void validateFineTuningExists(Integer id) {
        if (fineTuningMapper.selectById(id) == null) {
            throw exception(FINE_TUNING_NOT_EXISTS);
        }
    }

    @Override
    public FineTuningDO getFineTuning(Integer id) {
        return fineTuningMapper.selectById(id);
    }

    @Override
    public PageResult<FineTuningDO> getFineTuningPage(FineTuningPageReqVO pageReqVO) {
        return fineTuningMapper.selectPage(pageReqVO);
    }

}